"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const generator_1 = require("@babel/generator");
const parser_1 = require("@babel/parser");
const traverse_1 = require("@babel/traverse");
class BabelHelper {
    static parse(code) {
        return parser_1.parse(code, this.createOptions());
    }
    static createOptions() {
        return {
            plugins: [
                'asyncGenerators',
                'bigInt',
                'classProperties',
                'dynamicImport',
                'flow',
                'jsx',
                'objectRestSpread',
                ['decorators', { decoratorsBeforeExport: true }],
            ],
            sourceType: 'unambiguous'
        };
    }
    static getNodes(ast) {
        const nodes = [];
        traverse_1.default(ast, {
            enter(path) {
                const node = path.node;
                node.parent = path.parent;
                Object.freeze(node);
                nodes.push(node);
            },
        });
        return nodes;
    }
    static generateCode(ast) {
        return generator_1.default(ast).code;
    }
}
exports.default = BabelHelper;
//# sourceMappingURL=BabelHelper.js.map